Index: src/org/jboss/tools/deltacloud/core/job/RefreshCloudJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/RefreshCloudJob.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/job/RefreshCloudJob.java	(revision 0)
@@ -0,0 +1,25 @@
+package org.jboss.tools.deltacloud.core.job;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.jboss.tools.deltacloud.core.Activator;
+import org.jboss.tools.deltacloud.core.DeltaCloud;
+import org.jboss.tools.deltacloud.core.DeltaCloudMultiException;
+
+public class RefreshCloudJob extends AbstractCloudJob {
+
+	public RefreshCloudJob(DeltaCloud cloud) {
+		super("Refreshing images and instances on " + cloud.getName(), cloud);
+	}
+
+	protected IStatus doRun(IProgressMonitor monitor) throws Exception {
+		try {
+			getCloud().loadChildren();
+		} catch (DeltaCloudMultiException e) {
+			return Activator.createMultiStatus(e);
+		}
+		return Status.OK_STATUS;
+	}
+
+}
Index: src/org/jboss/tools/deltacloud/core/DeltaCloudDriver.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudDriver.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudDriver.java	(revision 0)
@@ -0,0 +1,46 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core;
+
+import org.jboss.tools.deltacloud.core.client.API.Driver;
+
+
+/**
+ * @author André Dietisheim
+ */
+public enum DeltaCloudDriver {
+
+	MOCK(Driver.MOCK), EC2(Driver.EC2), UNKNOWN(Driver.UNKNOWN);
+
+	private Driver driver;
+
+	private DeltaCloudDriver(Driver driver) {
+		this.driver = driver;
+	}
+	
+	public static DeltaCloudDriver valueOf(Driver driver) {
+		for(DeltaCloudDriver deltaCloudDriver : values()) {
+			if (deltaCloudDriver.driver.equals(driver)) {
+				return deltaCloudDriver;
+			}
+		}
+		return UNKNOWN;
+	}
+
+	public static DeltaCloudDriver checkedValueOf(String name) {
+		for (DeltaCloudDriver driver : values()) {
+			if (driver.name().equals(name)) {
+				return driver;
+			}
+		}
+		return UNKNOWN;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/DeltaCloudKey.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudKey.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudKey.java	(working copy)
@@ -17,6 +17,7 @@
  */
 public class DeltaCloudKey extends AbstractDeltaCloudElement {
 
+	
 	private Key key;
 
 	public DeltaCloudKey(Key key, DeltaCloud cloud) {
@@ -41,10 +42,13 @@
 	public String getPem() {
 		return key.getPem();
 	}
-
+	
 	@Override
 	public String toString() {
 		return "DeltaCloudKey [key=" + key + "]";
 	}
 
+	protected Key getKey() {
+		return key;
+	}
 }
Index: src/org/jboss/tools/deltacloud/core/client/Key.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Key.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/Key.java	(working copy)
@@ -16,7 +16,7 @@
 /**
  * @author Andre Dietisheim
  */
-public class Key extends AbstractDeltaCloudActionAwareObject<KeyAction> {
+public class Key extends StateAware<Key> {
 
 	private static final long serialVersionUID = 1L;
 
@@ -44,10 +44,6 @@
 		this.fingerprint = fingerprint;
 	}
 
-	public void setState(String state) {
-		this.state = state;
-	}
-
 	public URL getUrl() {
 		return url;
 	}
@@ -60,10 +56,6 @@
 		return pem;
 	}
 
-	public String getState() {
-		return state;
-	}
-
 	@Override
 	public String toString() {
 		return "Key [url=" + url + ", pem=" + pem + ", fingerprint=" + fingerprint + ", state=" + state + ", actions="
Index: src/org/jboss/tools/deltacloud/core/client/StateAware.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/StateAware.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/StateAware.java	(revision 0)
@@ -0,0 +1,46 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+
+/**
+ * @author André Dietisheim
+ *
+ * @param <OWNER>
+ */
+public class StateAware<OWNER> extends ActionAware<OWNER> {
+
+	public static enum State {
+		RUNNING, STOPPED, PENDING, TERMINATED, BOGUS
+	};
+
+	private State state;
+
+	public void setState(String state) {
+		try {
+			this.state = State.valueOf(state);
+		} catch (Exception e) {
+			this.state = State.BOGUS;
+		}
+	}
+
+	public State getState() {
+		return state;
+	}
+
+	public boolean isRunning() {
+		return getState() == State.RUNNING;
+	}
+
+	public boolean isStopped() {
+		return getState() == State.STOPPED;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/AllMatcher.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/AllMatcher.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/AllMatcher.java	(revision 0)
@@ -0,0 +1,32 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core;
+
+/**
+ * @author Jeff Johnston
+ * @author André Dietisheim
+ */
+public class AllMatcher implements IFieldMatcher {
+
+	@Override
+	public boolean matches(String input) {
+		return true;
+	}
+	
+	@Override
+	public String toString() {
+		return ICloudElementFilter.ALL_MATCHER_EXPRESSION;
+	}
+
+	public boolean isMatchesAll() {
+		return true;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/DeltaCloudXMLBuilder.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloudXMLBuilder.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloudXMLBuilder.java	(working copy)
@@ -29,6 +29,8 @@
 	public static final String ATTR_INSTANCEFILTER = "instancefilter";
 	public static final String ATTR_LASTKEYNAME = "lastkeyname";
 	public static final String ATTR_LASTIMAGE = "lastimage";
+	public static final String ATTR_LASTPROFILE = "lastprofile";
+	public static final String ATTR_LASTREALM = "lastrealm";
 	
 	public static final void xmlHeader(PrintWriter printWriter) {
 		printWriter.print("<?xml version=\"1.0\" encoding=\"");
Index: src/org/jboss/tools/deltacloud/core/client/Property.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Property.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/Property.java	(working copy)
@@ -15,7 +15,7 @@
 /**
  * @author Martyn Taylor
  */
-public class Property extends AbstractDeltaCloudObject {
+public class Property extends IdAware {
 
 	private static final long serialVersionUID = 1L;
 
Index: src/org/jboss/tools/deltacloud/core/DeltaCloud.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/DeltaCloud.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/DeltaCloud.java	(working copy)
@@ -15,18 +15,18 @@
 import java.util.Collection;
 import java.util.Iterator;
 import java.util.List;
-import java.util.regex.PatternSyntaxException;
 
 import org.eclipse.core.runtime.IProgressMonitor;
+import org.jboss.tools.deltacloud.core.DeltaCloudInstance.State;
+import org.jboss.tools.deltacloud.core.client.API.Driver;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudAuthClientException;
+import org.jboss.tools.deltacloud.core.client.DeltaCloudClient;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl;
-import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl.DeltaCloudServerType;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudNotFoundClientException;
 import org.jboss.tools.deltacloud.core.client.HardwareProfile;
 import org.jboss.tools.deltacloud.core.client.Image;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.InternalDeltaCloudClient;
 import org.jboss.tools.deltacloud.core.client.Key;
 import org.jboss.tools.deltacloud.core.client.Realm;
 import org.jboss.tools.internal.deltacloud.core.observable.ObservablePojo;
@@ -37,6 +37,8 @@
  */
 public class DeltaCloud extends ObservablePojo {
 
+	private static final int WAIT_FOR_STATE_DELAY = 4000;
+
 	public static final String PROP_INSTANCES = "instances";
 	public static final String PROP_INSTANCES_REMOVED = "instancesRemoved";
 	public static final String PROP_IMAGES = "images";
@@ -45,13 +47,15 @@
 	private String name;
 	private String username;
 	private String url;
-	private Driver driver;
+	private DeltaCloudDriver driver;
 	private String lastKeyname = "";
 	private String lastImageId = "";
-
-	private InternalDeltaCloudClient client;
+	private String lastRealmName = "";
+	private String lastProfileId = "";
+	
+	private DeltaCloudClient client;
 
-	private DeltaCloudImagesRepository images;
+	private DeltaCloudImagesRepository imagesRepo;
 	private DeltaCloudInstancesRepository instanceRepo;
 
 	private IImageFilter imageFilter;
@@ -60,26 +64,22 @@
 	private SecurePasswordStore passwordStore;
 	private Collection<IInstanceAliasMapping> instanceAliasMappings;
 
-	public static interface IInstanceStateMatcher {
-		public boolean matchesState(DeltaCloudInstance instance, DeltaCloudInstance.State instanceState);
-	}
-
 	public DeltaCloud(String name, String url, String username, String passwd) throws DeltaCloudException {
 		this(name, url, username, passwd, null);
 	}
 
-	public DeltaCloud(String name, String url, String username, String password, Driver driver)
+	public DeltaCloud(String name, String url, String username, String password, DeltaCloudDriver driver)
 			throws DeltaCloudException {
-		this(name, url, username, password, driver, IImageFilter.ALL_STRING, IInstanceFilter.ALL_STRING, new ArrayList<IInstanceAliasMapping>());
+		this(name, url, username, password, driver, null, null, new ArrayList<IInstanceAliasMapping>());
 	}
 
-	public DeltaCloud(String name, String url, String username, Driver driver, String imageFilterRules,
+	public DeltaCloud(String name, String url, String username, DeltaCloudDriver driver, String imageFilterRules,
 			String instanceFilterRules, Collection<IInstanceAliasMapping> instanceAliasMappings)
 			throws DeltaCloudException {
 		this(name, url, username, null, driver, imageFilterRules, instanceFilterRules, instanceAliasMappings);
 	}
 
-	public DeltaCloud(String name, String url, String username, String password, Driver driver,
+	public DeltaCloud(String name, String url, String username, String password, DeltaCloudDriver driver,
 			String imageFilterRules, String instanceFilterRules, Collection<IInstanceAliasMapping> instanceAliasMappings)
 			throws DeltaCloudException {
 		this.url = url;
@@ -88,29 +88,28 @@
 		this.driver = driver;
 		this.passwordStore = createSecurePasswordStore(name, username, password);
 		this.client = createClient(url, username, passwordStore.getPassword());
-		this.imageFilter = createImageFilter(imageFilterRules);
-		this.instanceFilter = createInstanceFilter(instanceFilterRules);
+		this.imageFilter = new ImageFilter(imageFilterRules, this);
+		this.instanceFilter = new InstanceFilter(instanceFilterRules, this);
 		this.instanceAliasMappings = instanceAliasMappings;
 	}
 
-	public void update(String name, String url, String username, String password, Driver driver)
+	public void update(String name, String url, String username, String password, DeltaCloudDriver driver)
 			throws DeltaCloudException {
 		this.driver = driver;
 
-		boolean nameChanged = updateName(name);
+		boolean nameChanged = updateName(name); 
 		boolean connectionPropertiesChanged = updateConnectionProperties(url, username, password);
 
-		if (connectionPropertiesChanged) {
-			client = createClient(url, username, password);
-			loadChildren();
-		}
-
 		if (nameChanged || connectionPropertiesChanged) {
 			this.passwordStore.update(new DeltaCloudPasswordStorageKey(name, username), password);
 			// TODO: move to notification based approach
 			DeltaCloudManager.getDefault().saveClouds();
 		}
 
+		if (connectionPropertiesChanged) {
+			client = createClient(url, username, password);
+			loadChildren();
+		}
 	}
 
 	private boolean updateName(String name) {
@@ -149,7 +148,7 @@
 		return new SecurePasswordStore(new DeltaCloudPasswordStorageKey(name, username), password);
 	}
 
-	protected InternalDeltaCloudClient createClient(String url, String username, String password)
+	protected DeltaCloudClient createClient(String url, String username, String password)
 			throws DeltaCloudException {
 		try {
 			return new DeltaCloudClientImpl(url, username, password);
@@ -174,13 +173,13 @@
 		return passwordStore.getPassword();
 	}
 
-	public Driver getDriver() {
+	public DeltaCloudDriver getDriver() {
 		return driver;
 	}
 
 	public boolean isValid() {
 		return driver != null
-				&& driver != Driver.UNKNOWN;
+				&& driver != DeltaCloudDriver.UNKNOWN;
 	}
 
 	public String getLastImageId() {
@@ -195,6 +194,22 @@
 		this.lastImageId = lastImageId;
 	}
 
+	public void setLastRealmName(String lastRealmName) {
+		this.lastRealmName = lastRealmName;
+	}
+
+	public String getLastRealmName() {
+		return lastRealmName;
+	}
+
+	public void setLastProfileId(String lastProfileId) {
+		this.lastProfileId = lastProfileId;
+	}
+
+	public String getLastProfileId() {
+		return lastProfileId;
+	}
+
 	private void setName(String name) {
 		firePropertyChange(PROP_NAME, this.name, this.name = name);
 	}
@@ -211,62 +226,27 @@
 		return instanceFilter;
 	}
 
-	public void updateInstanceFilter(String ruleString) throws Exception {
-		String rules = getInstanceFilter().toString();
-		instanceFilter = createInstanceFilter(ruleString);
-		if (!rules.equals(ruleString)) {
-			// TODO: remove notification with all instanceRepo, replace by
-			// notifying the changed instance
-			firePropertyChange(
+	public void updateInstanceFilter(String nameRule, String idRule, String aliasRule, String imageIdRule,
+			String ownerIdRule, String keyNameRule, String realmRule, String profileRule) throws Exception {
+		instanceFilter =
+				new InstanceFilter(nameRule, idRule, aliasRule, imageIdRule, ownerIdRule, keyNameRule, realmRule,
+						profileRule, this);
+		firePropertyChange(
 					PROP_INSTANCES, getInstancesRepository().get(), getInstancesRepository().get());
-			DeltaCloudManager.getDefault().saveClouds();
-		}
-	}
-
-	private IInstanceFilter createInstanceFilter(String ruleString) {
-		IInstanceFilter instanceFilter = null;
-		if (IInstanceFilter.ALL_STRING.equals(ruleString)) {
-			instanceFilter = new AllInstanceFilter(this);
-		} else {
-			try {
-				instanceFilter = new InstanceFilter(this);
-				instanceFilter.setRules(ruleString);
-			} catch (PatternSyntaxException e) {
-				instanceFilter.setRules(IInstanceFilter.ALL_STRING);
-			}
-		}
-		return instanceFilter;
+		DeltaCloudManager.getDefault().saveClouds();
 	}
 
 	public IImageFilter getImageFilter() {
 		return imageFilter;
 	}
 
-	public void updateImageFilter(String ruleString) throws Exception {
-		String rules = getImageFilter().toString();
-		this.imageFilter = createImageFilter(ruleString);
-		if (!rules.equals(ruleString)) {
-			// TODO: remove notification with all instanceRepo, replace by
-			// notifying the changed instance
-			firePropertyChange(PROP_IMAGES, getImagesRepository().get(), getImagesRepository().get());
-			// TODO: move to notification based approach
-			DeltaCloudManager.getDefault().saveClouds();
-		}
-	}
-
-	private IImageFilter createImageFilter(String ruleString) {
-		IImageFilter imageFilter = null;
-		if (IImageFilter.ALL_STRING.equals(ruleString)) {
-			imageFilter = new AllImageFilter(this);
-		} else {
-			try {
-				imageFilter = new ImageFilter(this);
-				imageFilter.setRules(ruleString);
-			} catch (PatternSyntaxException e) {
-				imageFilter.setRules(IImageFilter.ALL_STRING);
-			}
-		}
-		return imageFilter;
+	public void updateImageFilter(String nameRule, String idRule, String archRule, String descRule) throws Exception {
+		this.imageFilter = new ImageFilter(nameRule, idRule, archRule, descRule, this);
+		// TODO: remove notification with all instanceRepo, replace by
+		// notifying the changed instance
+		firePropertyChange(PROP_IMAGES, getImagesRepository().get(), getImagesRepository().get());
+		// TODO: move to notification based approach
+		DeltaCloudManager.getDefault().saveClouds();
 	}
 
 	/**
@@ -297,30 +277,18 @@
 		}
 	}
 
-	public DeltaCloudInstance waitForState(String instanceId, final DeltaCloudInstance.State expectedState,
+	public DeltaCloudInstance waitForState(String instanceId, DeltaCloudInstance.State expectedState,
 			IProgressMonitor pm)
 			throws InterruptedException, DeltaCloudException {
-		IInstanceStateMatcher stateMatcher = new IInstanceStateMatcher() {
-
-			@Override
-			public boolean matchesState(DeltaCloudInstance instance, DeltaCloudInstance.State instanceState) {
-				return expectedState != null
-						&& expectedState.equals(instanceState);
-			}
-		};
-		return waitForState(instanceId, stateMatcher, pm);
-	}
-
-	public DeltaCloudInstance waitForState(String instanceId, IInstanceStateMatcher stateMatcher, IProgressMonitor pm)
-			throws InterruptedException, DeltaCloudException {
 		DeltaCloudInstance instance = getInstancesRepository().getById(instanceId);
 		if (instance != null) {
 			while (!pm.isCanceled()) {
-				if (stateMatcher.matchesState(instance, instance.getState())
-						|| instance.getState().equals(DeltaCloudInstance.State.TERMINATED)) {
+				State state = instance.getState();
+				if (state == expectedState
+						|| instance.isInState(DeltaCloudInstance.State.TERMINATED)) {
 					return instance;
 				}
-				Thread.sleep(400);
+				Thread.sleep(WAIT_FOR_STATE_DELAY);
 				instance = refreshInstance(instance);
 			}
 		}
@@ -350,18 +318,26 @@
 			firePropertyChange(PROP_INSTANCES, oldInstances, repo.get());
 		} catch (DeltaCloudClientException e) {
 			throw new DeltaCloudException(MessageFormat.format(
-					"Could not load instanceRepo of cloud {0}: {1}", getName(), e.getMessage()), e);
+					"Could not load instances of cloud {0}: {1}", getName(), e.getMessage()), e);
 		}
 	}
 
 	private void clearImages() {
-		if (images != null) {
+		if (imagesRepo != null) {
 			// TODO: remove notification with all instanceRepo, replace by
 			// notifying the changed instance
-			firePropertyChange(PROP_IMAGES, images.get(), images.clear());
+			firePropertyChange(PROP_IMAGES, imagesRepo.get(), imagesRepo.clear());
 		}
 	}
 
+	public boolean imagesLoaded() {
+		return imagesRepo == null ? false : true;
+	}
+
+	public boolean instancesLoaded() {
+		return instanceRepo == null ? false : true;
+	}
+
 	private void clearInstances() {
 		// TODO: remove notification with all instanceRepo, replace by
 		// notifying the changed instance
@@ -389,17 +365,17 @@
 	}
 
 	private DeltaCloudImagesRepository getImagesRepository() {
-		if (images == null) {
-			images = new DeltaCloudImagesRepository();
+		if (imagesRepo == null) {
+			imagesRepo = new DeltaCloudImagesRepository();
 		}
-		return images;
+		return imagesRepo;
 	}
 
 	public DeltaCloudImage[] getImages() throws DeltaCloudException {
-		if (images == null) {
+		if (imagesRepo == null) {
 			loadImages();
 		}
-		return images.get();
+		return imagesRepo.get();
 	}
 
 	/**
@@ -417,7 +393,7 @@
 			try {
 				Image image = client.listImages(id);
 				deltaCloudImage = DeltaCloudImageFactory.create(image, this);
-				images.add(deltaCloudImage);
+				imagesRepo.add(deltaCloudImage);
 			} catch (DeltaCloudClientException e) {
 				throw new DeltaCloudException(MessageFormat.format("Cloud not find image with id \"{0}\"", id), e);
 			}
@@ -462,11 +438,12 @@
 		}
 	}
 
-	public void deleteKey(String keyname) throws DeltaCloudException {
+	public boolean delete(DeltaCloudKey deltaCloudKey) throws DeltaCloudException {
+		Key key = deltaCloudKey.getKey();
 		try {
-			client.deleteKey(keyname);
+			return key.destroy(client);
 		} catch (DeltaCloudClientException e) {
-			throw new DeltaCloudException(e);
+			throw new DeltaCloudException(MessageFormat.format("Could not delete key \"{0}\"", key.getId()), e);
 		}
 	}
 
@@ -479,17 +456,17 @@
 			return deltaCloudInstance;
 		} catch (DeltaCloudClientException e) {
 			// TODO : internationalize strings
-			throw new DeltaCloudException(MessageFormat.format("Coud not refresh instance \"{0}\"",
+			throw new DeltaCloudException(MessageFormat.format("Could not refresh instance \"{0}\"",
 					deltaCloudInstance.getId()), e);
 		}
 	}
 
-	public boolean performInstanceAction(String instanceId, DeltaCloudInstance.Action action)
+	public boolean performInstanceAction(String instanceId, DeltaCloudResourceAction action)
 			throws DeltaCloudException {
-		return performInstanceAction(getInstancesRepository().getById(instanceId), action);
+		return performAction(getInstancesRepository().getById(instanceId), action);
 	}
 
-	protected boolean performInstanceAction(DeltaCloudInstance instance, DeltaCloudInstance.Action action)
+	protected boolean performAction(DeltaCloudInstance instance, DeltaCloudResourceAction action)
 			throws DeltaCloudException {
 		try {
 			if (instance == null) {
@@ -497,9 +474,9 @@
 			}
 			DeltaCloudInstancesRepository repo = getInstancesRepository();
 			DeltaCloudInstance[] instances = repo.get();
-			boolean result = instance.performInstanceAction(action, client);
+			boolean result = instance.performAction(action, client);
 			if (result) {
-				if (DeltaCloudInstance.Action.DESTROY.equals(action)) {
+				if (DeltaCloudResourceAction.DESTROY.equals(action)) {
 					repo.remove(instance);
 					firePropertyChange(PROP_INSTANCES_REMOVED, null, instance);
 				}
@@ -604,10 +581,10 @@
 		return name;
 	}
 
-	public static Driver getServerDriver(String url) throws DeltaCloudException {
+	public static DeltaCloudDriver getServerDriver(String url) throws DeltaCloudException {
 		try {
-			DeltaCloudServerType serverType = new DeltaCloudClientImpl(url).getServerType();
-			return Driver.valueOf(serverType);
+			Driver driver = new DeltaCloudClientImpl(url).getServerType();
+			return DeltaCloudDriver.valueOf(driver);
 		} catch (Exception e) {
 			// TODO internationalize strings
 			throw new DeltaCloudException(
Index: src/org/jboss/tools/deltacloud/core/client/API.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/API.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/API.java	(revision 0)
@@ -0,0 +1,55 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat Inc..
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat Incorporated - initial API and implementation
+ *******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+/**
+ * @author Andre Dietisheim
+ */
+public class API extends IdAware {
+
+	private static final long serialVersionUID = 1L;
+
+	public static enum Driver {
+		UNKNOWN, MOCK, EC2;
+
+		public static Driver checkedValueOf(String name) {
+			for (Driver driver : values()) {
+				if (driver.name().equals(name)) {
+					return driver;
+				}
+			}
+			return UNKNOWN;
+		}
+
+	}
+
+	private Driver driver;
+
+	public API() {
+	}
+
+	public void setDriver(Driver driver) {
+		this.driver = driver;
+	}
+
+	public void setDriver(String driver) {
+		setDriver(Driver.checkedValueOf(driver.toUpperCase()));
+	}
+
+	public Driver getDriver() {
+		return driver;
+	}
+
+	@Override
+	public String toString() {
+		return "API [driver=" + driver.name() + super.toString() + "]";
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/InstanceFilter.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/InstanceFilter.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/InstanceFilter.java	(working copy)
@@ -11,7 +11,6 @@
 package org.jboss.tools.deltacloud.core;
 
 import java.util.Iterator;
-import java.util.regex.PatternSyntaxException;
 
 /**
  * A filter that may be applied on DeltaCloudInstances
@@ -23,44 +22,80 @@
  */
 public class InstanceFilter extends AbstractCloudElementFilter<DeltaCloudInstance> implements IInstanceFilter {
 
+	private IFieldMatcher aliasRule;
 	private IFieldMatcher imageIdRule;
-	private IFieldMatcher realmRule;
-	private IFieldMatcher profileRule;
 	private IFieldMatcher ownerIdRule;
 	private IFieldMatcher keyNameRule;
+	private IFieldMatcher realmRule;
+	private IFieldMatcher profileRule;
 
 	public InstanceFilter(DeltaCloud cloud) {
+		this(new AllMatcher(), new AllMatcher(), new AllMatcher(), new AllMatcher(), new AllMatcher(),
+				new AllMatcher(), new AllMatcher(), new AllMatcher(), cloud);
+	}
+
+	public InstanceFilter(IFieldMatcher nameMatcher, IFieldMatcher idMatcher, IFieldMatcher aliasMatcher,
+			IFieldMatcher imageIdMatcher, IFieldMatcher ownerIdMatcher, IFieldMatcher keyMatcher,
+			IFieldMatcher realmMatcher, IFieldMatcher profileMatcher, DeltaCloud cloud) {
+		super(nameMatcher, idMatcher, cloud);
+		setRules(aliasMatcher, imageIdMatcher, ownerIdMatcher, keyMatcher, realmMatcher, profileMatcher);
+	}
+
+	public InstanceFilter(String rulesString, DeltaCloud cloud) {
 		super(cloud);
+		setRules(rulesString);
+	}
+
+	public InstanceFilter(String nameRule, String idRule, String aliasRule, String imageIdRule,
+			String ownerIdRule, String keyNameRule, String realmRule, String profileRule, DeltaCloud cloud) {
+		super(nameRule, idRule, cloud);
+		setRules(aliasRule, imageIdRule, ownerIdRule, keyNameRule, realmRule, profileRule);
 	}
-	
+
 	@Override
-	public boolean matches(DeltaCloudInstance instance) {
-		return super.matches(instance) &&
-		imageIdRule.matches(instance.getImageId()) &&
-		ownerIdRule.matches(instance.getOwnerId()) &&
-		keyNameRule.matches(instance.getKeyId()) &&
-		realmRule.matches(instance.getRealmId()) &&
-		profileRule.matches(instance.getProfileId());
+	protected Iterator<String> setRules(String rules) {
+		Iterator<String> rulesIterator = super.setRules(rules);
+		setRules(createRule(rulesIterator), createRule(rulesIterator), createRule(rulesIterator),
+				createRule(rulesIterator), createRule(rulesIterator), createRule(rulesIterator));
+		return rulesIterator;
+	}
+
+	private void setRules(String aliasRule, String imageIdRule, String ownerIdRule, String keyNameRule,
+			String realmRule, String profileRule) {
+		setRules(createRule(aliasRule), createRule(imageIdRule), createRule(ownerIdRule), createRule(keyNameRule),
+				createRule(realmRule), createRule(profileRule));
+	}
+
+	private void setRules(IFieldMatcher aliasMatcher, IFieldMatcher imageIdMatcher, IFieldMatcher ownerIdMatcher,
+			IFieldMatcher keyNameMatcher, IFieldMatcher realmMatcher, IFieldMatcher profileMatcher) {
+		this.aliasRule = aliasMatcher;
+		this.imageIdRule = imageIdMatcher;
+		this.keyNameRule = keyNameMatcher;
+		this.ownerIdRule = ownerIdMatcher;
+		this.realmRule = realmMatcher;
+		this.profileRule = profileMatcher;
 	}
 
 	@Override
-	public void setRules(String ruleString) throws PatternSyntaxException {
-		Iterator<String> rulesIterator = super.setRules(ruleString, getRulesIterator(ruleString));
-		this.imageIdRule = createRule(rulesIterator);
-		this.ownerIdRule = createRule(rulesIterator);
-		this.keyNameRule = createRule(rulesIterator);
-		this.realmRule = createRule(rulesIterator);
-		this.profileRule = createRule(rulesIterator);
+	public boolean matches(DeltaCloudInstance instance) {
+		return super.matches(instance) &&
+				aliasRule.matches(instance.getAlias()) &&
+				imageIdRule.matches(instance.getImageId()) &&
+				ownerIdRule.matches(instance.getOwnerId()) &&
+				keyNameRule.matches(instance.getKeyId()) &&
+				realmRule.matches(instance.getRealmId()) &&
+				profileRule.matches(instance.getProfileId());
 	}
-	
+
 	@Override
 	public String toString() {
 		return super.toString()
-		+ imageIdRule + ";" //$NON-NLS-1$
-		+ ownerIdRule + ";" //$NON-NLS-1$
-		+ keyNameRule + ";" //$NON-NLS-1$
-		+ realmRule + ";" //$NON-NLS-1$
-		+ profileRule; //$NON-NLS-1$
+				+ aliasRule + EXPRESSION_DELIMITER
+				+ imageIdRule + EXPRESSION_DELIMITER
+				+ ownerIdRule + EXPRESSION_DELIMITER
+				+ keyNameRule + EXPRESSION_DELIMITER
+				+ realmRule + EXPRESSION_DELIMITER
+				+ profileRule; //$NON-NLS-1$
 	}
 
 	@Override
@@ -69,6 +104,11 @@
 	}
 
 	@Override
+	public IFieldMatcher getAliasRule() {
+		return aliasRule;
+	}
+
+	@Override
 	public IFieldMatcher getKeyNameRule() {
 		return keyNameRule;
 	}
@@ -87,4 +127,14 @@
 	public IFieldMatcher getRealmRule() {
 		return realmRule;
 	}
+
+	public boolean isFiltering() {
+		return super.isFiltering()
+				|| !aliasRule.isMatchesAll()
+				|| !imageIdRule.isMatchesAll()
+				|| !keyNameRule.isMatchesAll()
+				|| !ownerIdRule.isMatchesAll()
+				|| !profileRule.isMatchesAll()
+				|| !realmRule.isMatchesAll();
+	}
 }
